#include "asmUtil.h"
#include "printf.h"
#include "cc111x.h"
#include "adc.h"

//adc is not really 12 bits in single ended mode. max is 0x7ff

static uint16_t adcPrvSample(uint8_t input)	//virtual sources only. returns adcval << 4
{
	uint16_t ret;
	
	ADCH = 0;
	ADCCON2 = 0x30 | input;
	ADCCON1 = 0x73;
	while (ADCCON1 & 0x40);
	while (!(ADCCON1 & 0x80));
	
	ret = ADCL;
	ret |= (((uint16_t)ADCH << 8));
	
	ADCCON2 = 0;
	
	return ret;
}

uint16_t adcSampleBattery(void)
{
	return mathPrvMul16x16(mathPrvDiv16x8(adcPrvSample(15), 35), 4);	//within 3%
}

int8_t adcSampleTemperature(void)
{
	return mathPrvDiv16x8(adcPrvSample(14), 66) - 300;
	
	//to get calibrated temp in units of 0.1 degreesC
	// (sext(AdcVal) * 1250 - uext(tokenGet(0x09)) * 0x7ff) * 1000 / tokenGet(0x12) * 10 / 0x7ff
}
