#ifndef _EEPROM_MAP_H_
#define _EEPROM_MAP_H_

#include <stdint.h>
#include "eeprom.h"

#define EEPROM_UNIQUE_ID_ADR			(0x00064)
#define EEPROM_UNIQUE_ID_LEN			(13)

#define EEPROM_SETTINGS_AREA_START		(0x08000UL)
#define EEPROM_SETTINGS_AREA_LEN		(0x04000UL)

//some free space here

#define EEPROM_UPDATA_AREA_START		(0x10000UL)
#define EEPROM_UPDATE_AREA_LEN			(0x09000UL)

#define EEPROM_IMG_START				(0x19000UL)
#define EEPROM_IMG_EACH					(0x17000UL)
//till end of eeprom really. do not put anything after - it will be erased at pairing time!!!

#define EEPROM_IMG_INPROGRESS			(0x7fffffffUL)
#define EEPROM_IMG_VALID				(0x494d4721UL)

#define EEPROM_PIECE_SZ					(88)
struct EepromImageHeader {				//each image space is 0x17000 bytes, we have space for ten of them
	uint64_t version;
	uint32_t validMarker;
	uint32_t size;
	uint32_t rfu[8];				//zero-filled for now
	uint8_t piecesMissing[192];		//each bit represents a EEPROM_PIECE_SZ-byte piece
	
	//image data here
	//we pre-erase so progress can be calculated by finding the first non-0xff byte
};

#if (EEPROM_SETTINGS_AREA_LEN % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "settings area must be an integer number of eeprom blocks"
#endif

#if (EEPROM_SETTINGS_AREA_START % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "settings must begin at an integer number of eeprom blocks"
#endif

#if (EEPROM_IMG_EACH % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "each image must be an integer number of eeprom blocks"
#endif

#if (EEPROM_IMG_START % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "images must begin at an integer number of eeprom blocks"
#endif

#if (EEPROM_UPDATE_AREA_LEN % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "update must be an integer number of eeprom blocks"
#endif

#if (EEPROM_UPDATA_AREA_START % EEPROM_ERZ_SECTOR_SZ) != 0
	#error "images must begin at an integer number of eeprom blocks"
#endif





#endif

